module.exports = {
  parser: '@typescript-eslint/parser',
  parserOptions: {
    ecmaVersion: 2020,
    sourceType: 'module',
    ecmaFeatures: {
      jsx: true,
    },
  },
  settings: {
    react: {
      version: 'detect',
    },
  },
  extends: [
    'plugin:@typescript-eslint/recommended',
    'prettier/@typescript-eslint',
    'plugin:react/recommended',
    'plugin:prettier/recommended',
  ],
  plugins: ['prettier', 'only-warn'],
  rules: {
    '@typescript-eslint/ban-ts-comment': ['off'],
    'react/prop-types': ['off'],
    '@typescript-eslint/explicit-module-boundary-types': ['off'],
  },
}
