import React, { useEffect } from 'react'
import { io } from 'socket.io-client'

import { Box } from '@chakra-ui/react'
import { Canvas } from 'react-three-fiber'

import MenuOverlay from './MenuOverlay'
import Scene from '../3d'

import useStore from '../store'

const Museo: React.FC = () => {
  const setSocket = useStore((state) => state.setSocket)
  useEffect(() => {
    const socket = io()
    setSocket(socket)

    return () => {
      socket.close()
      setSocket(null)
    }
  }, [])
  return (
    <Box w="100vw" h="100vh">
      <MenuOverlay />
      <Canvas colorManagement>
        <Scene />
      </Canvas>
    </Box>
  )
}

export default Museo
