import path from 'path'
import dotenv from 'dotenv'
dotenv.config({ path: path.join(__dirname, '../../../.env') })

import { Strategy } from 'passport-facebook'

import { Router } from 'express'
import passport from 'passport'

import genericStrategy from '../strategy'

const strategyOptions = {
  clientID: process.env.FACEBOOK_CLIENT_ID,
  clientSecret: process.env.FACEBOOK_CLIENT_SECRET,
  callbackURL: '/auth/facebook/redirect',
  profileFields: ['id', 'displayName', 'picture.type(large)', 'email'],
}

export function facebookStrategy() {
  return new Strategy(strategyOptions, genericStrategy('facebook'))
}

export const facebookRouter = Router()

const facebookAuthenticateOptions = {
  authType: 'rerequest',
  scope: ['email'],
}

facebookRouter.get(
  '/facebook',
  passport.authenticate('facebook', facebookAuthenticateOptions),
)
facebookRouter.get(
  '/facebook/redirect',
  passport.authenticate('facebook', { successRedirect: '/museo', failureRedirect: '/' }),
)
